DECLARE EXTERNAL SUB turtle.fd, turtle.bk, turtle.rt, turtle.lt, turtle.pu, turtle.pd
SET WINDOW -1,19,-10,10
SET LINE COLOR 10
CALL rt(90)
INPUT k
CALL sugi(k,18)
SUB sugi(k, l)
   CALL sugiha(k, l, 1)
END SUB
SUB sugiha(k, l, s)
   IF k < 1 THEN
      IF s = 0 THEN
         CALL trir(l)
      ELSE
         CALL tril(l)
      END IF   
   ELSE
      IF s = 0 THEN
         CALL rt(30)
      ELSE
         CALL lt(30)
      END IF
      CALL sugiha(k-1, l/SQR(3), MOD(s+1,2))
      IF s = 1 THEN
         CALL rt(30)
      ELSE
         CALL lt(30)
      END IF
      CALL fd(l/3)
      CALL sugiha(k-1, l*2/3, MOD(s+1,2))
      CALL pu
      CALL bk(l/3)
      CALL pd
   END IF
END SUB
SUB tril(l)
   CALL fd(l)
   CALL lt(150)
   CALL fd(l/SQR(3))
   CALL lt(60)
   CALL fd(l/SQR(3))
   CALL lt(150)
END SUB
SUB trir(l)
   CALL fd(l)
   CALL rt(150)
   CALL fd(l/SQR(3))
   CALL rt(60)
   CALL fd(l/SQR(3))
   CALL rt(150)
END SUB
END
! LOGO^[gOtBbNX
MODULE turtle
MODULE OPTION ANGLE DEGREES
PUBLIC SUB fd, bk, rt, lt, pu, pd
SHARE NUMERIC curX, curY, direction
SHARE STRING pen$
LET curX=0
LET curY=0
LET direction=90
LET pen$="down"
EXTERNAL SUB fd(r)  ! Forward Oi
   LET x0=curX
   LET y0=curY
   LET curX=curX+r*COS(direction)
   LET curY=curY+r*SIN(direction)
   IF pen$="down" THEN PLOT LINES: x0,y0; curX, curY
END SUB
EXTERNAL SUB bk(r)  ! Back i
   LET x0=curX
   LET y0=curY
   LET curX=curX-r*COS(direction)
   LET curY=curY-r*SIN(direction)
   IF pen$="down" THEN PLOT LINES: x0,y0; curX, curY
END SUB
EXTERNAL SUB rt(t)  ! Right Turn E]
   LET direction=direction - t
END SUB
EXTERNAL SUB lt(t)  ! Left Turn ]
   LET direction=direction + t
END SUB
EXTERNAL SUB pu     ! Pen Up 
   LET pen$="up"
END SUB
EXTERNAL SUB pd     ! Pen Down
   LET pen$="down"
END SUB
END MODULE
