DECLARE EXTERNAL SUB turtle.fd, turtle.bk, turtle.rt, turtle.lt, turtle.pu, turtle.pd
SET WINDOW -10,10,-5,15
INPUT PROMPT ",px,F":kaisu,kakudo,iro
SET LINE COLOR iro
CALL tree(kaisu,6,kakudo)
SUB tree(k, l, r)
   IF k > 0 THEN
      CALL fd(l/3)
      CALL lt(r)
      CALL tree(k-1, l/2, r)
      CALL fd(l/2)
      CALL pu
      CALL bk(l/2)
      CALL pd
      CALL rt(r)
      CALL fd(l/3)
      CALL rt(r)
      CALL tree(k-1, l/2, r)
      CALL fd(l/2)
      CALL pu
      CALL bk(l/2)
      CALL pd
      CALL lt(r)
      CALL fd(l/3)
      CALL tree(k-1, l/2, r)
      CALL fd(l/2)
      CALL pu
      CALL bk(l*1.5)
      CALL pd
   END IF
END SUB
END
! LOGO^[gOtBbNX
MODULE turtle
MODULE OPTION ANGLE DEGREES
PUBLIC SUB fd, bk, rt, lt, pu, pd
SHARE NUMERIC curX, curY, direction
SHARE STRING pen$
LET curX=0
LET curY=0
LET direction=90
LET pen$="down"
EXTERNAL SUB fd(r)  ! Forward Oi
   LET x0=curX
   LET y0=curY
   LET curX=curX+r*COS(direction)
   LET curY=curY+r*SIN(direction)
   IF pen$="down" THEN PLOT LINES: x0,y0 ; curX, curY
END SUB
EXTERNAL SUB bk(r)  ! Back i
   LET x0=curX
   LET y0=curY
   LET curX=curX-r*COS(direction)
   LET curY=curY-r*SIN(direction)
   IF pen$="down" THEN PLOT LINES: x0,y0 ; curX, curY
END SUB
EXTERNAL SUB rt(t)  ! Right Turn E]
   LET direction=direction - t
END SUB
EXTERNAL SUB lt(t)  ! Left Turn ]
   LET direction=direction + t
END SUB
EXTERNAL SUB pu     ! Pen Up 
   LET pen$="up"
END SUB
EXTERNAL SUB pd     ! Pen Down
   LET pen$="down"
END SUB
END MODULE
